import java.util.ArrayList;
import java.util.Random;
import java.lang.Math;

import commandcenter.CommandCenter;
import enumerate.Action;
import enumerate.State;
import structs.FrameData;
import structs.GameData;
import structs.Key;
import gameInterface.AIInterface;

public class BitterCoffeeFTGAI implements AIInterface {
	private Key inputKey;
	private boolean aiplayer;
	private FrameData fd;
	private CommandCenter _CommandCenter;
	private GameData gd;
	private Combo[] AllSkills;
	Random rnd;
	Random swap_rnd;

	@Override
	public int initialize(GameData gameData, boolean playerNumber) {
		// TODO Auto-generated method stub
		inputKey = new Key();
		aiplayer = playerNumber;
		fd = new FrameData();
		_CommandCenter = new CommandCenter();
		gd = gameData;
		AllSkills = Combo.GetAll();

		this.rnd = new Random();
		this.swap_rnd = new Random();
		return 0;
	}

	@Override
	public void getInformation(FrameData frameData) {
		// TODO Auto-generated method stub
		fd = frameData;
		_CommandCenter.setFrameData(fd, aiplayer);
	}

	@Override
	public void processing() {
		// TODO Auto-generated method stub
		if (!fd.emptyFlag && fd.getRemainingTime() > 0) {
			boolean myAiIsAir = false;
			State myAiState = _CommandCenter.getMyCharacter().getState();
			/*--------------------获取自己信息-------------------*/
			switch (myAiState) {
			case AIR:
				myAiIsAir = true;
				break;
			}
			/*----------------------End-----------------------*/

			boolean opponentIsAir = false;
			State opponentState = _CommandCenter.getEnemyCharacter().getState();
			/*--------------------获取对手信息-------------------*/
			switch (opponentState) {
			case AIR:
				opponentIsAir = true;
				break;
			}
			/*----------------------End-----------------------*/

			switch (GetFightState(myAiIsAir, opponentIsAir)) {
			case SameAir:
				SameAirHandler();// 对打双方都在空中
				break;
			case SameGround:
				SameGroundHandler();// 对打双方都在地面
				break;
			case Opposite:
				OppositeHandler();// 对打双方一个在空中一个在地面
				break;
			}
		}
	}

	@Override
	public Key input() {
		// TODO Auto-generated method stub
		return inputKey;
	}

	@Override
	public void close() {
		// TODO Auto-generated method stub

	}

	// 对打双方都在空中
	private void SameAirHandler() {
		// x轴距离
		int DX = _CommandCenter.getDistanceX();
		// 角度的余弦值
		double CosXY = GetFightData()[1];
		ArrayList<Combo> list = new ArrayList<Combo>();
		Random _random = new Random();
		// 距离小于100
		if (DX <= 100) {
			if (CosXY < 0.5 && CosXY != 1) {
				// 角度大于60
				CastCombo(GetGuard());
			} else {
				// 对打双人角度较小,更不容易被攻击到,则出在空中能用的技能
				for (int i = 0; i < AllSkills.length; i++) {
					if (AllSkills[i].GetAttackType().equals(AttackType.Middle)
							&& AllSkills[i].GetInAir() == 1) {
						list.add(AllSkills[i]);
					}
				}
				CastCombo(list.get(_random.nextInt(list.size())).GetAction());
			}
		} else if (DX > 100 && DX <= 300) {
			// 距离在100到300,则不断使用在空中能用的技能
			for (int i = 0; i < AllSkills.length; i++) {
				if (AllSkills[i].GetAttackType().equals(AttackType.Middle)
						&& AllSkills[i].GetInAir() == 1) {
					list.add(AllSkills[i]);
				}
			}
			CastCombo(list.get(_random.nextInt(list.size())).GetAction());
		} else if (DX > 300) {
			// 距离大于300,防御尽快落地
			CastCombo(GetGuard());
		}
	}

	// 对打双方都在地面
	private void SameGroundHandler() {
		// 直线距离
		double DLine = GetFightData()[0];
		State opponentState = _CommandCenter.getEnemyCharacter().getState();
		ArrayList<Combo> list = new ArrayList<Combo>();
		Random _random = new Random();
		if (DLine < 100) {
			if (DLine < 60) {
				// 距离小于60,释放投掷
				for (int i = 0; i < AllSkills.length; i++) {
					if (AllSkills[i].GetAttackType().equals(AttackType.Throw)) {
						list.add(AllSkills[i]);
					}
				}
				CastCombo(list.get(_random.nextInt(list.size())).GetAction());
			} else {
				// 距离大于60,释放除投掷之外的技能
				if (opponentState.equals(State.STAND)) {
					// 对手站姿,则出下段技能或远程技能
					for (int i = 0; i < AllSkills.length; i++) {
						if (AllSkills[i].GetAttackType().equals(AttackType.Low)
								|| AllSkills[i].GetSpecial() == 1) {
							list.add(AllSkills[i]);
						}
					}
				} else {
					// 对手是蹲姿则出除投掷之外的任意技能
					for (int i = 0; i < AllSkills.length; i++) {
						if (AllSkills[i].GetAttackType().equals(AttackType.Low)) {
							list.add(AllSkills[i]);
						}
					}
				}
				CastCombo(list.get(_random.nextInt(list.size())).GetAction());
			}
		} else if (DLine >= 100) {
			// 距离大于100,不断施放远程技能
			for (int i = 0; i < AllSkills.length; i++) {
				if (AllSkills[i].GetSpecial() == 1
						&& AllSkills[i].GetNeedEnergy() <= _CommandCenter
								.getMyCharacter().getEnergy()) {
					list.add(AllSkills[i]);
				}
			}
			CastCombo(list.get(_random.nextInt(list.size())).GetAction());
		}
	}

	// 对打双方一个在空中一个在地面
	private void OppositeHandler() {
		double DLine = GetFightData()[0];
		double CosXY = GetFightData()[1];
		State myAiState = _CommandCenter.getMyCharacter().getState();
		State opponentState = _CommandCenter.getEnemyCharacter().getState();
		ArrayList<Combo> list = new ArrayList<Combo>();
		Random _random = new Random();
		if (DLine < 100) {
			// 距离小于100
			if (myAiState.equals(State.AIR)) {
				// 自己在空中,则防御
				CastCombo(GetGuard());
			} else {
				// 自己不在空中,对手在空中,防御等待落地后的抛投或其他技能
				CastCombo(GetGuard());
			}
		} else if (DLine > 100 && DLine <= 320) {
			// 距离在100到300之间
			if (myAiState.equals(State.AIR)) {
				// 自己在空中,则释放能在空中释放的技能
				for (int i = 0; i < AllSkills.length; i++) {
					if (AllSkills[i].GetInAir() == 1) {
						list.add(AllSkills[i]);
					}
				}
				CastCombo(list.get(_random.nextInt(list.size())).GetAction());
			} else if (myAiState.equals(State.DOWN)) {
				// 倒地则防御
				CastCombo(Action.CROUCH_GUARD);
			} else {
				// 自己在地面
				// 对手在空中则不断释放远程技能,不释放消耗能量的技能
				for (int i = 0; i < AllSkills.length; i++) {
					if (AllSkills[i].GetSpecial() == 1
							&& AllSkills[i].GetNeedEnergy() <= 0) {
						list.add(AllSkills[i]);
					}
				}
				CastCombo(list.get(_random.nextInt(list.size())).GetAction());
			}
		} else {
			// 其他位置则一直防御,等待对手靠近
			CastCombo(Action.CROUCH_GUARD);
		}
	}

	// 获取双方战斗状态
	private FightState GetFightState(boolean P1IsAir, boolean P2IsAir) {
		if (P1IsAir || P2IsAir) {
			if (P1IsAir && P2IsAir) {
				return FightState.SameAir;
			} else {
				return FightState.Opposite;
			}
		} else {
			return FightState.SameGround;
		}
	}

	// 根据Action枚举释放技能
	private void CastCombo(Action _action) {
		if (!_CommandCenter.getskillFlag()) {
			inputKey.empty();
			_CommandCenter.skillCancel();
			_CommandCenter.commandCall(_action.toString());
		} else {
			inputKey = _CommandCenter.getSkillKey();
		}
	}

	// 防御
	private Action GetGuard() {
		Action returnAction;
		switch (_CommandCenter.getMyCharacter().getState()) {
		case STAND:
			returnAction = Action.STAND_GUARD;
			break;
		case DOWN:
		case CROUCH:
			returnAction = Action.CROUCH_GUARD;
			break;
		case AIR:
			returnAction = Action.AIR_GUARD;
			break;
		default:
			returnAction = Action.STAND_GUARD;
			break;
		}
		return returnAction;
	}

	private double[] GetFightData() {
		double enemyDX = _CommandCenter.getDistanceX();
		double enemyDY = _CommandCenter.getDistanceY();
		// 直线距离
		double enemyD = enemyDY <= 0 ? enemyDX : enemyDX <= 0 ? enemyDY : (Math
				.ceil(Math.sqrt(Math.pow(enemyDX, 2) + Math.pow(enemyDY, 2))));
		// 值越大离得越近越高
		double enemyCos = enemyDX > 0 && enemyDY > 0 ? (Math
				.ceil((enemyDX / enemyD) * 100) / 100) : 1;
		return new double[] { enemyD, enemyCos };
	}
}
